﻿/// <reference name="MicrosoftAjax.js"/>

Type.registerNamespace('ForgottenExtenders');

ForgottenExtenders.PrintablePanelBehavior = function(element) {

    ForgottenExtenders.PrintablePanelBehavior.initializeBase(this, [element]);

    this._printButtonID = null;
    this._styleSheetFilePath = null;
}

ForgottenExtenders.PrintablePanelBehavior.prototype = {

    initialize: function() {
        ForgottenExtenders.PrintablePanelBehavior.callBaseMethod(this, 'initialize');

        // TODO: add your initalization code here
        var btn = $get(this._printButtonID);
        $addHandler(btn, 'click', Function.createDelegate(this, this._onclick));
    },

    dispose: function() {
        // TODO: add your cleanup code here
        $clearHandlers(this.get_element());
        ForgottenExtenders.PrintablePanelBehavior.callBaseMethod(this, 'dispose');
    },

    _onclick: function(e) {
        var panel = this.get_element();
        var btn = $get(this._printButtonID);

        if (panel != 'undefined') {
            var sb = new Sys.StringBuilder();
            var panelContent = new String(panel.innerHTML).trim().toLowerCase();

            sb.appendLine("<html>");
            sb.appendLine("<head>");
            sb.appendLine("<link href='" + this._styleSheetFilePath + "' rel=\"stylesheet\" type=\"text/css\" />");
            sb.appendLine("</head>");
            sb.appendLine("<body>");
            sb.appendLine(panelContent);
            sb.appendLine("</body>");
            sb.appendLine("</html>");

            var win = window.open("", "PrintWindow", null, null);

            win.document.write(sb.toString());
            win.document.close();
            win.focus();
            win.print();
            win.close();

            // cancel the button click event
            e.preventDefault();
        }

    },

    //Properties
    get_PrintButtonID: function() {
        return this._printButtonID;
    },

    set_PrintButtonID: function(value) {
        this._printButtonID = value;
    },

    get_StyleSheetFilePath: function() {
        return this._styleSheetFilePath;
    },

    set_StyleSheetFilePath: function(value) {
        this._styleSheetFilePath = value;
    }

}

ForgottenExtenders.PrintablePanelBehavior.registerClass('ForgottenExtenders.PrintablePanelBehavior', AjaxControlToolkit.BehaviorBase);

if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded(); 