﻿using System;
using System.Design;
using System.Web.UI.Design;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AjaxControlToolkit;
using System.ComponentModel;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing.Design;

[assembly: System.Web.UI.WebResource("ForgottenExtenders.PrintablePanel.PrintablePanelBehavior.js", "text/javascript")]


namespace ForgottenExtenders {

    [Designer(typeof(PrintablePanelDesigner))]
    [ClientScriptResource("ForgottenExtenders.PrintablePanelBehavior", "ForgottenExtenders.PrintablePanel.PrintablePanelBehavior.js")]
    [TargetControlType(typeof(Panel))]
    public class PrintablePanelExtender : ExtenderControlBase {

        [ExtenderControlProperty]
        [IDReferenceProperty(typeof(Button))]
        [Description("The ID of the button control that will trigger print action.")]
        public string PrintButtonID {
            get {
                return GetPropertyValue("PrintButtonID", "");
            }
            set {
                SetPropertyValue("PrintButtonID", value);
            }
        }

        [ExtenderControlProperty]
        [Description( "The stylesheet file used to style the printable content." )]
        [EditorAttribute( typeof( UrlEditor ), typeof( UITypeEditor ) )]
        public string StyleSheetFilePath {
            get { 
                return GetPropertyValue( "StyleSheetFilePath", "" );
            }
            set {
                SetPropertyValue( "StyleSheetFilePath", ResolveClientUrl(value) );
            }
        }
    }
}
