using System;
using System.Web.UI.WebControls;
using System.Web.UI;
using System.ComponentModel;
using System.ComponentModel.Design;
using AjaxControlToolkit;
using System.Collections.Generic;

[assembly: System.Web.UI.WebResource("ForgottenExtenders.TextBoxCharacterCount.TextBoxCharacterCountBehavior.js", "text/javascript")]

namespace ForgottenExtenders {

    [Designer( typeof( TextBoxCharacterCountDesigner ) )]
    [ClientScriptResource("ForgottenExtenders.TextBoxCharacterCountBehavior", "ForgottenExtenders.TextBoxCharacterCount.TextBoxCharacterCountBehavior.js")]
    [TargetControlType( typeof( TextBox ) )]
    public class TextBoxCharacterCountExtender : ExtenderControlBase {

        [ExtenderControlProperty]
        [IDReferenceProperty( typeof( TextBox ) )]
        [Description( "The maximum length characters typed in this textbox should not exceed." )]
        public string MaximumLength {
            get {
                return GetPropertyValue( "MaximumLength" , "" );
            }
            set {
                SetPropertyValue( "MaximumLength" , value );
            }
        }

        [ExtenderControlProperty]
        [IDReferenceProperty( typeof( TextBox ) )]
        [Description("The ID of a div tag in which a message displaying the number of characters remaining will be displayed.")]
        public string DisplayDIV {
            get {
                return GetPropertyValue( "DisplayDIV" , "" );
            }
            set {
                SetPropertyValue( "DisplayDIV" , value );
            }
        }

    }
}
