﻿/// <reference name="MicrosoftAjax.js"/>
/// <reference path="../../../Binaries/jquery-1.3.2-vsdoc.js" />

Type.registerNamespace('ForgottenExtenders');

ForgottenExtenders.VirtualEarthPanelBehavior = function(element) {

    ForgottenExtenders.VirtualEarthPanelBehavior.initializeBase(this, [element]);

    this._centerLatitude = null;
    this._centerLongitude = null;
    this._centerTitle = null;
    this._centerDescription = null;
    this._mapCssClass = null;

}

ForgottenExtenders.VirtualEarthPanelBehavior.prototype = {

    initialize: function() {
        ForgottenExtenders.VirtualEarthPanelBehavior.callBaseMethod(this, 'initialize');

        // initialize
        this._loadMap();

    },

    dispose: function() {
        $clearHandlers(this.get_element());
        ForgottenExtenders.VirtualEarthPanelBehavior.callBaseMethod(this, 'dispose');
    },

    _loadMap: function() {
        var panel = this.get_element();
        
        // make sure the panel is empty
        $(panel).html("");
        
        if (this._mapCssClass == null || this._mapCssClass == '') {
            $(panel)
                .css("position", "absolute")
                .css("width", "400px")
                .css("height", "400px")
                .css("border", "#555555 1px solid");

        } else {
            // make sure the panel is empty
            $(panel).addClass(this._mapCssClass);
        }

        var map = new VEMap(panel.id);
        var center = new VELatLong(this._centerLatitude, this._centerLongitude);
        map.LoadMap(center, 14, VEMapStyle.Road, false, VEMapMode.Mode2D, false, 1);

        // Add a new pushpin to the center of the map.
        var pin = map.AddPushpin(center);
        pin.SetTitle(this._centerTitle);
        pin.SetDescription(this._centerDescription);

    },

    get_CenterLatitude: function() {
        return this._centerLatitude;
    },

    set_CenterLatitude: function(value) {
        this._centerLatitude = value;
    },

    get_CenterLongitude: function() {
        return this._centerLongitude;
    },

    set_CenterLongitude: function(value) {
        this._centerLongitude = value;
    },

    get_CenterTitle: function() {
        return this._centerTitle;
    },

    set_CenterTitle: function(value) {
        this._centerTitle = value;
    },

    get_CenterDescription: function() {
        return this._centerDescription;
    },

    set_CenterDescription: function(value) {
        this._centerDescription = value;
    },

    get_MapCssClass: function() {
        return this._mapCssClass;
    },

    set_MapCssClass: function(value) {
        this._mapCssClass = value;
    }
}

ForgottenExtenders.VirtualEarthPanelBehavior.registerClass('ForgottenExtenders.VirtualEarthPanelBehavior', AjaxControlToolkit.BehaviorBase);

if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded(); 