﻿using System;
using System.Design;
using System.Web.UI.Design;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AjaxControlToolkit;
using System.ComponentModel;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing.Design;

[assembly: System.Web.UI.WebResource( "ForgottenExtenders.VirtualEarthPanel.VirtualEarthPanelBehavior.js", "text/javascript" )]

namespace ForgottenExtenders {

    [Designer(typeof(VirtualEarthPanelDesigner))]
    [ClientScriptResource( "ForgottenExtenders.VirtualEarthPanelBehavior", "ForgottenExtenders.VirtualEarthPanel.VirtualEarthPanelBehavior.js" )]
    [TargetControlType(typeof(Panel))]
    [RequiredScript(typeof(CommonScripts),1)]   
    public class VirtualEarthPanelExtender : ExtenderControlBase {

        [ExtenderControlProperty]
        [Description( "The latitude of the map center." )]
        public double CenterLatitude {
            get {
                return GetPropertyValue( "CenterLatitude", 0.0 );
            }
            set {
                SetPropertyValue( "CenterLatitude", value );
            }
        }

        [ExtenderControlProperty]
        [Description( "The longitude of the map center." )]
        public double CenterLongitude {
            get {
                return GetPropertyValue( "CenterLongitude", 0.0 );
            }
            set {
                SetPropertyValue( "CenterLongitude", value );
            }
        }

        [ExtenderControlProperty]
        [Description( "The title of the location at the map's center ." )]
        public string CenterTitle {
            get {
                return GetPropertyValue( "CenterTitle", "" );
            }
            set {
                SetPropertyValue( "CenterTitle", value );
            }
        }

        [ExtenderControlProperty]
        [Description( "The description of the location at the map's center ." )]
        public string CenterDescription {
            get {
                return GetPropertyValue( "CenterDescription", "" );
            }
            set {
                SetPropertyValue( "CenterDescription", value );
            }
        }

        [ExtenderControlProperty]
        [Description( "The CSS class to apply to the map control." )]
        [CssClassProperty]
        public string MapCssClass {
            get {
                return GetPropertyValue( "MapCssClass", "" );
            }
            set {
                SetPropertyValue( "MapCssClass", value );
            }
        }

        protected override IEnumerable<ScriptReference> GetScriptReferences( ) {
            if (Visible) {
                List<ScriptReference> scriptRefs = new List<ScriptReference>( );

                // add virtual earth script
                scriptRefs.Add( new ScriptReference( "http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.2" ) );

                // add behavior scripts
                scriptRefs.AddRange( ScriptObjectBuilder.GetScriptReferences( GetType( ), false ) );

                return scriptRefs;
            }
            return null;
        }
    }
}
